summaryrefslogtreecommitdiff
path: root/tests/rm/deep-2
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rm/deep-2')
-rwxr-xr-xtests/rm/deep-253
1 files changed, 53 insertions, 0 deletions
diff --git a/tests/rm/deep-2 b/tests/rm/deep-2
new file mode 100755
index 000000000..d5e1b572c
--- /dev/null
+++ b/tests/rm/deep-2
@@ -0,0 +1,53 @@
+#!/bin/sh
+# Ensure rm -r DIR does not prompt for very long full relative names in DIR.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+. $srcdir/../test-lib.sh
+
+# Root can run this test, but it always succeeds, since for root, all
+# files are writable, and write_protected_non_symlink never reaches
+# the offending euidaccess_stat call.
+skip_if_root_
+
+mkdir x || framework_failure
+cd x || framework_failure
+
+# Construct a hierarchy containing a relative file with a name
+: ${PERL=perl}
+$PERL \
+ -e 'my $d = "x" x 200; foreach my $i (1..52)' \
+ -e ' { mkdir ($d, 0700) && chdir $d or die "$!" }' \
+ || framework_failure
+
+cd .. || framework_failure
+echo n > no || framework_failure
+
+fail=0
+rm ---presume-input-tty -r x < no > out || fail=1
+
+# expect empty output
+test -s out && fail=1
+
+# the directory must have been removed
+test -d x && fail=1
+
+(exit $fail); exit $fail